﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Raven.Client;
using Raven.Client.Documents;
using Raven.Client.Documents.Changes;
using Raven.Client.Documents.Indexes;
using Raven.Client.Documents.Operations.Indexes;
using Raven.Client.Documents.Session;
using Raven.Client.Server;
using Raven.Client.Server.Operations;
using Raven.Client.Server.Operations.ApiKeys;

namespace ConsoleApplication1
{
	public class Program
	{
		public class TestObject
		{
			public string Id { get; set; }
			public string Name { get; set; }
			public long Etag { get; set; }
		}

		static void Main(string[] args)
		{
			var documentStore = new DocumentStore { Urls = new[] { "http://localhost:8081" }, Database = "TestDatabase" };
			documentStore.Initialize();

			documentStore.Dispose();

			documentStore = new DocumentStore { Urls = new[] { "http://localhost:8081" }, Database = "TestDatabase" };
			documentStore.Initialize();

			documentStore.OnAfterStore += (sender, e) =>
			                              {
				                              var entityWithEtag = e.Entity as TestObject;
				                              if (entityWithEtag != null)
					                              entityWithEtag.Etag = (long) e.DocumentMetadata["@etag"];
			                              };

			var to = new TestObject { Name = "Test Object" };
			using (var session = documentStore.OpenSession())
			{
				session.Store(to);
				session.SaveChanges();
			}

			to.Name = "Something Else";
			using (var session = documentStore.OpenSession())
				session.Store(to, to.Etag, to.Id);

			//The following line fixes the exception...
			//documentStore.Dispose();
		}
	}
}
